Subject: bug#61676: package transformations not honored working from a manifest

From: Ludovic Courtès <[email-masked]>
Date: Wed, 22 Feb 2023 10:23:55 +0100

Hello,

Maxim Cournoyer <[email-masked]> skribis:

> Ludovic Courtès <[email-masked]> writes:
>
> [...]
>
>>> But noticed that --with-source and --with-patch were not effective for
>>> the jami-with-certs customized package provided by the
>>> guix-pack-manifest.scm manifest.
>>
>> Indeed, that’s expected.
>>
>>> It seems to me that the rewriting options should be honored on any
>>> packages being manipulated, whether they come from the Guix collection,
>>> a file, a manifest or another means.
>>
>> I’m not convinced; I think manifests should be interpreted literally.
>
> Perhaps I do not have the full picture in my head, but if someone calls
> 'guix pack -m my-manifest.scm
> --with-source=some-package=the-source.tar.gz', it'd seem the
> --with-source option pretty useless in this case if it doesn't touch the
> manifest's packages graph.  It'd rather it error out with a message
> like: "package rewriting options have no effects for manifests",
> although I'd rather it was possible.
>
> Is there another alternative for the use case I'm after?  The only other
> option available seems to be to extend the GUIX_PACKAGE_PATH with a
> module and to use -e '(@@ (my module) jami-with-certs)'; would the
> jami-with-certs graph get rewritten then?

How about using transformations right into your manifest?  Would that
work for you?

There’s a one-to-one mapping from command-line options to
‘options->transformation’ (info "(guix) Defining Package Variants").

Ludo’.